## suitesparse 4.5.4

=== Makefile ===
#-------------------------------------------------------------------------------
# Makefile for all SuiteSparse packages
#-------------------------------------------------------------------------------

SUITESPARSE = $(CURDIR)
export SUITESPARSE

default: go

include SuiteSparse_config/SuiteSparse_config.mk

# Compile the default rules for each package
go: metis
	( cd SuiteSparse_config && $(MAKE) )
	( cd AMD && $(MAKE) )
	( cd BTF && $(MAKE) )
	( cd CAMD && $(MAKE) )
	( cd CCOLAMD && $(MAKE) )
	( cd COLAMD && $(MAKE) )
	( cd CHOLMOD && $(MAKE) )
	( cd CSparse && $(MAKE) )
	( cd CXSparse && $(MAKE) )
	( cd LDL && $(MAKE) )
	( cd KLU && $(MAKE) )
	( cd UMFPACK && $(MAKE) )
	( cd RBio && $(MAKE) )
ifneq ($(GPU_CONFIG),)
	( cd SuiteSparse_GPURuntime && $(MAKE) )
	( cd GPUQREngine && $(MAKE) )
endif
	( cd SPQR && $(MAKE) )
#	( cd PIRO_BAND && $(MAKE) )
#	( cd SKYLINE_SVD && $(MAKE) )

# install all packages in /usr/local/lib and /usr/local/include
# (note that CSparse is not installed; CXSparse is installed instead)
install: metis
	( cd SuiteSparse_config && $(MAKE) install )
	( cd AMD && $(MAKE) install )
	( cd BTF && $(MAKE) install )
	( cd CAMD && $(MAKE) install )
	( cd CCOLAMD && $(MAKE) install )
	( cd COLAMD && $(MAKE) install )
	( cd CHOLMOD && $(MAKE) install )
	( cd CXSparse && $(MAKE) install )
	( cd LDL && $(MAKE) install )
	( cd KLU && $(MAKE) install )
	( cd UMFPACK && $(MAKE) install )
	( cd RBio && $(MAKE) install )
ifneq (,$(GPU_CONFIG))
	( cd SuiteSparse_GPURuntime && $(MAKE) install )
	( cd GPUQREngine && $(MAKE) install )
endif
	( cd SPQR && $(MAKE) install )
#	( cd PIRO_BAND && $(MAKE) install )
#	( cd SKYLINE_SVD && $(MAKE) install )
	$(CP) README.txt $(INSTALL_DOC)/SuiteSparse_README.txt
	chmod 644 $(INSTALL_DOC)/SuiteSparse_README.txt
ifeq (,$(MY_METIS_LIB))
        # install METIS from SuiteSparse/metis-5.1.0
	- $(CP) lib/libmetis.* $(INSTALL_LIB)
	- $(CP) metis-5.1.0/manual/manual.pdf $(INSTALL_DOC)/METIS_manual.pdf
	- $(CP) metis-5.1.0/README.txt $(INSTALL_DOC)/METIS_README.txt
        # the following is needed only on the Mac, so *.dylib is hardcoded:
	$(SO_INSTALL_NAME) $(INSTALL_LIB)/libmetis.dylib $(INSTALL_LIB)/libmetis.dylib
	- $(CP) include/metis.h $(INSTALL_INCLUDE)
	chmod 755 $(INSTALL_LIB)/libmetis.*
	chmod 644 $(INSTALL_INCLUDE)/metis.h
	chmod 644 $(INSTALL_DOC)/METIS_manual.pdf
	chmod 644 $(INSTALL_DOC)/METIS_README.txt
endif

# uninstall all packages
uninstall:
	$(RM) $(INSTALL_DOC)/SuiteSparse_README.txt
	( cd SuiteSparse_config && $(MAKE) uninstall )
	- ( cd metis-5.1.0 && $(MAKE) uninstall )
	( cd AMD && $(MAKE) uninstall )
	( cd CAMD && $(MAKE) uninstall )
	( cd COLAMD && $(MAKE) uninstall )
	( cd BTF && $(MAKE) uninstall )
	( cd KLU && $(MAKE) uninstall )
	( cd LDL && $(MAKE) uninstall )
	( cd CCOLAMD && $(MAKE) uninstall )
	( cd UMFPACK && $(MAKE) uninstall )
	( cd CHOLMOD && $(MAKE) uninstall )
	( cd CSparse && $(MAKE) uninstall )
	( cd CXSparse && $(MAKE) uninstall )
	( cd RBio && $(MAKE) uninstall )
	( cd SuiteSparse_GPURuntime && $(MAKE) uninstall )
	( cd GPUQREngine && $(MAKE) uninstall )
	( cd SPQR && $(MAKE) uninstall )
#	( cd PIRO_BAND && $(MAKE) uninstall )
#	( cd SKYLINE_SVD && $(MAKE) uninstall )
ifeq (,$(MY_METIS_LIB))
        # uninstall METIS, which came from SuiteSparse/metis-5.1.0
	$(RM) $(INSTALL_LIB)/libmetis.*
	$(RM) $(INSTALL_INCLUDE)/metis.h
	$(RM) $(INSTALL_DOC)/METIS_manual.pdf
	$(RM) $(INSTALL_DOC)/METIS_README.txt
endif
	$(RM) -r $(INSTALL_DOC)

# compile the dynamic libraries
library: metis
	( cd SuiteSparse_config && $(MAKE) )
	( cd AMD && $(MAKE) library )
	( cd BTF && $(MAKE) library )
	( cd CAMD && $(MAKE) library )
	( cd CCOLAMD && $(MAKE) library )
	( cd COLAMD && $(MAKE) library )
	( cd CHOLMOD && $(MAKE) library )
	( cd KLU && $(MAKE) library )
	( cd LDL && $(MAKE) library )
	( cd UMFPACK && $(MAKE) library )
	( cd CSparse && $(MAKE) library )
	( cd CXSparse && $(MAKE) library )
	( cd RBio && $(MAKE) library )
ifneq (,$(GPU_CONFIG))
	( cd SuiteSparse_GPURuntime && $(MAKE) library )
	( cd GPUQREngine && $(MAKE) library )
endif
	( cd SPQR && $(MAKE) library )
#	( cd PIRO_BAND && $(MAKE) library )
#	( cd SKYLINE_SVD && $(MAKE) library )

# compile the static libraries (except for metis, which is only dynamic)
static: metis
	( cd SuiteSparse_config && $(MAKE) static )
	( cd AMD && $(MAKE) static )
	( cd BTF && $(MAKE) static )
	( cd CAMD && $(MAKE) static )
	( cd CCOLAMD && $(MAKE) static )
	( cd COLAMD && $(MAKE) static )
	( cd CHOLMOD && $(MAKE) static )
	( cd KLU && $(MAKE) static )
	( cd LDL && $(MAKE) static )
	( cd UMFPACK && $(MAKE) static )
	( cd CSparse && $(MAKE) static )
	( cd CXSparse && $(MAKE) static )
	( cd RBio && $(MAKE) static )
ifneq (,$(GPU_CONFIG))
	( cd SuiteSparse_GPURuntime && $(MAKE) static )
	( cd GPUQREngine && $(MAKE) static )
endif
	( cd SPQR && $(MAKE) static )
#	( cd PIRO_BAND && $(MAKE) static )
#	( cd SKYLINE_SVD && $(MAKE) static )

# Remove all files not in the original distribution
purge:
	- ( cd SuiteSparse_config && $(MAKE) purge )
	- ( cd metis-5.1.0 && $(MAKE) distclean )
	- ( cd AMD && $(MAKE) purge )
	- ( cd CAMD && $(MAKE) purge )
	- ( cd COLAMD && $(MAKE) purge )
	- ( cd BTF && $(MAKE) purge )
	- ( cd KLU && $(MAKE) purge )
	- ( cd LDL && $(MAKE) purge )
	- ( cd CCOLAMD && $(MAKE) purge )
	- ( cd UMFPACK && $(MAKE) purge )
	- ( cd CHOLMOD && $(MAKE) purge )
	- ( cd CSparse && $(MAKE) purge )
	- ( cd CXSparse && $(MAKE) purge )
	- ( cd RBio && $(MAKE) purge )
	- ( cd MATLAB_Tools/UFcollection && $(RM) *.mex* )
	- ( cd MATLAB_Tools/SSMULT && $(RM) *.mex* )
	- ( cd SuiteSparse_GPURuntime && $(MAKE) purge )
	- ( cd GPUQREngine && $(MAKE) purge )
	- ( cd SPQR && $(MAKE) purge )
#	- ( cd PIRO_BAND && $(MAKE) purge )
#	- ( cd SKYLINE_SVD && $(MAKE) purge )
	- $(RM) MATLAB_Tools/*/*.mex* MATLAB_Tools/spok/private/*.mex*
	- $(RM) -r include/* bin/* lib/* share/*

# Remove all files not in the original distribution, but keep the libraries
clean:
	- ( cd SuiteSparse_config && $(MAKE) clean )
	- ( cd metis-5.1.0 && $(MAKE) clean )
	- ( cd AMD && $(MAKE) clean )
	- ( cd CAMD && $(MAKE) clean )
	- ( cd COLAMD && $(MAKE) clean )
	- ( cd BTF && $(MAKE) clean )
	- ( cd KLU && $(MAKE) clean )
	- ( cd LDL && $(MAKE) clean )
	- ( cd CCOLAMD && $(MAKE) clean )
	- ( cd UMFPACK && $(MAKE) clean )
	- ( cd CHOLMOD && $(MAKE) clean )
	- ( cd CSparse && $(MAKE) clean )
	- ( cd CXSparse && $(MAKE) clean )
	- ( cd RBio && $(MAKE) clean )
	- ( cd SuiteSparse_GPURuntime && $(MAKE) clean )
	- ( cd GPUQREngine && $(MAKE) clean )
	- ( cd SPQR && $(MAKE) clean )
#	- ( cd PIRO_BAND && $(MAKE) clean )
#	- ( cd SKYLINE_SVD && $(MAKE) clean )

# Create the PDF documentation
docs:
	( cd AMD && $(MAKE) docs )
	( cd CAMD && $(MAKE) docs )
	( cd KLU && $(MAKE) docs )
	( cd LDL && $(MAKE) docs )
	( cd UMFPACK && $(MAKE) docs )
	( cd CHOLMOD && $(MAKE) docs )
	( cd SPQR && $(MAKE) docs )
#	( cd PIRO_BAND && $(MAKE) docs )
#	( cd SKYLINE_SVD && $(MAKE) docs )

distclean: purge

# Create CXSparse from CSparse
# Note that the CXSparse directory should initially not exist.
cx:
	( cd CSparse ; $(MAKE) purge )
	( cd SuiteSparse_config && $(MAKE) )
	( cd CXSparse_newfiles ; tar cfv - * | gzip -9 > ../CXSparse_newfiles.tar.gz )
	./CSparse_to_CXSparse CSparse CXSparse CXSparse_newfiles.tar.gz
	( cd CXSparse/Demo ; $(MAKE) )
	( cd CXSparse/Demo ; $(MAKE) > cs_demo.out )
	( cd CXSparse ; $(MAKE) purge )
	$(RM) -f CXSparse_newfiles.tar.gz

# statement coverage (Linux only); this requires a lot of time.
# The umfpack tcov requires a lot of disk space in /tmp
cov: purge
	( cd CXSparse && $(MAKE) cov )
	( cd CSparse && $(MAKE) cov )
	( cd CHOLMOD && $(MAKE) cov )
	( cd KLU && $(MAKE) cov )
	( cd SPQR && $(MAKE) cov )
	( cd UMFPACK && $(MAKE) cov )
#	( cd PIRO_BAND && $(MAKE) cov )
#	( cd SKYLINE_SVD && $(MAKE) cov )

# configure and compile METIS, placing the libmetis.* library in
# SuiteSparse/lib and the metis.h include file in SuiteSparse/include.
metis: include/metis.h

# Install the shared version of METIS in SuiteSparse/lib.
# The SO_INSTALL_NAME commmand is only needed on the Mac, so *.dylib is
# hardcoded below.
include/metis.h:
ifeq (,$(MY_METIS_LIB))
	- ( cd metis-5.1.0 && $(MAKE) config shared=1 prefix=$(SUITESPARSE) )
	- ( cd metis-5.1.0 && $(MAKE) )
	- ( cd metis-5.1.0 && $(MAKE) install )
	- $(SO_INSTALL_NAME) $(SUITESPARSE)/lib/libmetis.dylib \
                             $(SUITESPARSE)/lib/libmetis.dylib
else
	@echo 'Using pre-installed METIS 5.1.0 library at ' '[$(MY_METIS_LIB)]'
endif

=== SuiteSparse_config/Makefile ===
#-------------------------------------------------------------------------------
# SuiteSparse_config Makefile
#-------------------------------------------------------------------------------

SUITESPARSE ?= $(realpath $(CURDIR)/..)
export SUITESPARSE

# version of SuiteSparse_config is also version of SuiteSparse meta-package
LIBRARY = libsuitesparseconfig
VERSION = 4.5.4
SO_VERSION = 4

default: library

include SuiteSparse_config.mk

ccode: all

all: library

# compile and install in SuiteSparse/lib
library: $(AR_TARGET)
	$(MAKE) install INSTALL=$(SUITESPARSE)

OBJ = SuiteSparse_config.o

SuiteSparse_config.o: SuiteSparse_config.c SuiteSparse_config.h
	$(CC) $(CF) -c SuiteSparse_config.c

static: $(AR_TARGET)

$(AR_TARGET): $(OBJ)
	$(ARCHIVE) $(AR_TARGET) SuiteSparse_config.o
	$(RANLIB) $(AR_TARGET)

distclean: purge

purge: clean
	( cd xerbla ; $(MAKE) purge )
	- $(RM) -r $(PURGE)

clean:
	( cd xerbla ; $(MAKE) clean )
	- $(RM) -r $(CLEAN)

# install SuiteSparse_config
install: $(AR_TARGET) $(INSTALL_LIB)/$(SO_TARGET)

$(INSTALL_LIB)/$(SO_TARGET): $(OBJ)
	@mkdir -p $(INSTALL_LIB)
	@mkdir -p $(INSTALL_INCLUDE)
	@mkdir -p $(INSTALL_DOC)
	$(CC) $(SO_OPTS) $^ -o $@ $(LDLIBS)
	( cd $(INSTALL_LIB) ; ln -sf $(SO_TARGET) $(SO_PLAIN) )
	( cd $(INSTALL_LIB) ; ln -sf $(SO_TARGET) $(SO_MAIN) )
	$(CP) SuiteSparse_config.h $(INSTALL_INCLUDE)
	$(CP) README.txt $(INSTALL_DOC)/SUITESPARSECONFIG_README.txt
	chmod 755 $(INSTALL_LIB)/$(SO_TARGET)
	chmod 755 $(INSTALL_LIB)/$(SO_PLAIN)
	chmod 644 $(INSTALL_INCLUDE)/SuiteSparse_config.h
	chmod 644 $(INSTALL_DOC)/SUITESPARSECONFIG_README.txt

# uninstall SuiteSparse_config
uninstall:
	$(RM) $(INSTALL_LIB)/$(SO_TARGET)
	$(RM) $(INSTALL_LIB)/$(SO_PLAIN)
	$(RM) $(INSTALL_LIB)/$(SO_MAIN)
	$(RM) $(INSTALL_INCLUDE)/SuiteSparse_config.h
	$(RM) $(INSTALL_DOC)/SUITESPARSECONFIG_README.txt
	( cd xerbla ; $(MAKE) uninstall )

=== AMD/Doc/Makefile ===
#------------------------------------------------------------------------------
# AMD Makefile for compiling on Unix systems
#------------------------------------------------------------------------------

default: dist

include ../../SuiteSparse_config/SuiteSparse_config.mk

#------------------------------------------------------------------------------
# Remove all but the files in the original distribution
#------------------------------------------------------------------------------

clean:
	- $(RM) -r $(CLEAN)

purge: distclean

distclean: clean
	- $(RM) -r $(PURGE)

#------------------------------------------------------------------------------
# Create the User Guide and Quick Start Guide
#------------------------------------------------------------------------------

AMD_UserGuide.pdf: AMD_UserGuide.tex AMD_UserGuide.bib ../Include/amd.h
	echo '\begin{verbatim}' > amd_h.tex
	expand -8 ../Include/amd.h >> amd_h.tex
	echo '\end{verbatim}' >> amd_h.tex
	pdflatex AMD_UserGuide
	bibtex AMD_UserGuide
	pdflatex AMD_UserGuide
	pdflatex AMD_UserGuide

dist:  AMD_UserGuide.pdf
	- $(RM) *.aux *.bbl *.blg *.log *.toc amd_h.tex

=== CAMD/Doc/Makefile ===
#------------------------------------------------------------------------------
# CAMD Makefile for compiling on Unix systems
#------------------------------------------------------------------------------

default: dist

include ../../SuiteSparse_config/SuiteSparse_config.mk

#------------------------------------------------------------------------------
# Remove all but the files in the original distribution
#------------------------------------------------------------------------------

clean:
	- $(RM) -r camd_temp $(CLEAN)

purge: distclean

distclean: clean
	- $(RM) -r $(PURGE)

#------------------------------------------------------------------------------
# Create the User Guide and Quick Start Guide
#------------------------------------------------------------------------------

CAMD_UserGuide.pdf: CAMD_UserGuide.tex CAMD_UserGuide.bib ../Include/camd.h
	echo '\begin{verbatim}' > camd_h.tex
	expand -8 ../Include/camd.h >> camd_h.tex
	echo '\end{verbatim}' >> camd_h.tex
	pdflatex CAMD_UserGuide
	bibtex CAMD_UserGuide
	pdflatex CAMD_UserGuide
	pdflatex CAMD_UserGuide

dist:  CAMD_UserGuide.pdf
	- $(RM) *.aux *.bbl *.blg *.log *.toc camd_h.tex
	- $(RM) camd_temp

=== CSparse/Lib/Makefile ===
# On the Mac, you need to first install Xcode.  Then
# type this command in the Terminal:
#       xcode-select --install
# to ensure that you have the command-line tools installed.
#
# To just compile the library, do:
#       make
#
# To run a demo using the library 
#       cd ../Demo ; make
#
# For system-wide installation, I recommend that you install CXSparse instead.
# The CSparse library is meant for personal experimentation.  The 'make
# install' in this Makefile only installs a static compiled library in
# CSparse/Lib.  It does not install it for system-wide usage.

LIBRARY = libcsparse

CF = $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -O -fPIC
I = -I../Include
RANLIB = ranlib
ARCHIVE = $(AR) $(ARFLAGS)
CP = cp -f

AR_TARGET = $(LIBRARY).a

all: install

CS = cs_add.o cs_amd.o cs_chol.o cs_cholsol.o cs_counts.o cs_cumsum.o \
	cs_droptol.o cs_dropzeros.o cs_dupl.o cs_entry.o \
	cs_etree.o cs_fkeep.o cs_gaxpy.o cs_happly.o cs_house.o cs_ipvec.o \
	cs_lsolve.o cs_ltsolve.o cs_lu.o cs_lusol.o cs_util.o cs_multiply.o \
	cs_permute.o cs_pinv.o cs_post.o cs_pvec.o cs_qr.o cs_qrsol.o \
	cs_scatter.o cs_schol.o cs_sqr.o cs_symperm.o cs_tdfs.o cs_malloc.o \
	cs_transpose.o cs_compress.o cs_usolve.o cs_utsolve.o cs_scc.o \
	cs_maxtrans.o cs_dmperm.o cs_updown.o cs_print.o cs_norm.o cs_load.o \
	cs_dfs.o cs_reach.o cs_spsolve.o cs_ereach.o cs_leaf.o cs_randperm.o

$(CS): ../Include/cs.h Makefile

%.o: ../Source/%.c ../Include/cs.h
	$(CC) $(CF) $(I) -c $<

static: $(AR_TARGET)

$(AR_TARGET): $(CS)
	$(ARCHIVE)  $@ $^
	- $(RANLIB) $@

# install CSparse in this directory
install: $(AR_TARGET)

# uninstall CSparse
uninstall: purge

clean:
	- $(RM) *.o

purge: distclean

distclean: clean
	- $(RM) *.a *.obj *.dll *.dylib *.so *.so.*

=== CXSparse_newfiles/Lib/Makefile ===
#-------------------------------------------------------------------------------
# CXSparse Lib/Makefile
#-------------------------------------------------------------------------------

LIBRARY = libcxsparse
VERSION = 3.1.9
SO_VERSION = 3

default: library

include ../../SuiteSparse_config/SuiteSparse_config.mk

# CXSparse depends on SuiteSparse_config
LDLIBS += -lsuitesparseconfig

# compile and install in SuiteSparse/lib
library:
	$(MAKE) install INSTALL=$(SUITESPARSE)

I = -I../../SuiteSparse_config -I../Include

all: library

CS_SOURCE = cs_add.c cs_amd.c cs_chol.c cs_cholsol.c cs_counts.c cs_cumsum.c \
	cs_droptol.c cs_dropzeros.c cs_dupl.c cs_entry.c \
	cs_etree.c cs_fkeep.c cs_gaxpy.c cs_happly.c cs_house.c cs_ipvec.c \
	cs_lsolve.c cs_ltsolve.c cs_lu.c cs_lusol.c cs_util.c cs_multiply.c \
	cs_permute.c cs_pinv.c cs_post.c cs_pvec.c cs_qr.c cs_qrsol.c \
	cs_scatter.c cs_schol.c cs_sqr.c cs_symperm.c cs_tdfs.c cs_malloc.c \
	cs_transpose.c cs_compress.c cs_usolve.c cs_utsolve.c cs_scc.c \
	cs_maxtrans.c cs_dmperm.c cs_updown.c cs_print.c cs_norm.c cs_load.c \
	cs_dfs.c cs_reach.c cs_spsolve.c cs_leaf.c cs_ereach.c cs_randperm.c

CS_DI_OBJ =  cs_add_di.o cs_amd_di.o cs_chol_di.o cs_cholsol_di.o cs_counts_di.o \
	cs_cumsum_di.o cs_droptol_di.o cs_dropzeros_di.o cs_dupl_di.o \
	cs_entry_di.o cs_etree_di.o cs_fkeep_di.o cs_gaxpy_di.o cs_happly_di.o \
	cs_house_di.o cs_ipvec_di.o cs_lsolve_di.o cs_ltsolve_di.o cs_lu_di.o \
	cs_lusol_di.o cs_util_di.o cs_multiply_di.o cs_permute_di.o cs_pinv_di.o \
	cs_post_di.o cs_pvec_di.o cs_qr_di.o cs_qrsol_di.o cs_scatter_di.o \
	cs_schol_di.o cs_sqr_di.o cs_symperm_di.o cs_tdfs_di.o cs_malloc_di.o \
	cs_transpose_di.o cs_compress_di.o cs_usolve_di.o cs_utsolve_di.o \
	cs_scc_di.o cs_maxtrans_di.o cs_dmperm_di.o cs_updown_di.o cs_print_di.o \
	cs_norm_di.o cs_load_di.o cs_dfs_di.o cs_reach_di.o cs_spsolve_di.o \
	cs_leaf_di.o cs_ereach_di.o cs_randperm_di.o

CS_DL_OBJ =  cs_add_dl.o cs_amd_dl.o cs_chol_dl.o cs_cholsol_dl.o cs_counts_dl.o \
	cs_cumsum_dl.o cs_droptol_dl.o cs_dropzeros_dl.o cs_dupl_dl.o \
	cs_entry_dl.o cs_etree_dl.o cs_fkeep_dl.o cs_gaxpy_dl.o cs_happly_dl.o \
	cs_house_dl.o cs_ipvec_dl.o cs_lsolve_dl.o cs_ltsolve_dl.o cs_lu_dl.o \
	cs_lusol_dl.o cs_util_dl.o cs_multiply_dl.o cs_permute_dl.o cs_pinv_dl.o \
	cs_post_dl.o cs_pvec_dl.o cs_qr_dl.o cs_qrsol_dl.o cs_scatter_dl.o \
	cs_schol_dl.o cs_sqr_dl.o cs_symperm_dl.o cs_tdfs_dl.o cs_malloc_dl.o \
	cs_transpose_dl.o cs_compress_dl.o cs_usolve_dl.o cs_utsolve_dl.o \
	cs_scc_dl.o cs_maxtrans_dl.o cs_dmperm_dl.o cs_updown_dl.o cs_print_dl.o \
	cs_norm_dl.o cs_load_dl.o cs_dfs_dl.o cs_reach_dl.o cs_spsolve_dl.o \
	cs_leaf_dl.o cs_ereach_dl.o cs_randperm_dl.o

CS_CI_OBJ =  cs_add_ci.o cs_amd_ci.o cs_chol_ci.o cs_cholsol_ci.o cs_counts_ci.o \
	cs_cumsum_ci.o cs_droptol_ci.o cs_dropzeros_ci.o cs_dupl_ci.o \
	cs_entry_ci.o cs_etree_ci.o cs_fkeep_ci.o cs_gaxpy_ci.o cs_happly_ci.o \
	cs_house_ci.o cs_ipvec_ci.o cs_lsolve_ci.o cs_ltsolve_ci.o cs_lu_ci.o \
	cs_lusol_ci.o cs_util_ci.o cs_multiply_ci.o cs_permute_ci.o cs_pinv_ci.o \
	cs_post_ci.o cs_pvec_ci.o cs_qr_ci.o cs_qrsol_ci.o cs_scatter_ci.o \
	cs_schol_ci.o cs_sqr_ci.o cs_symperm_ci.o cs_tdfs_ci.o cs_malloc_ci.o \
	cs_transpose_ci.o cs_compress_ci.o cs_usolve_ci.o cs_utsolve_ci.o \
	cs_scc_ci.o cs_maxtrans_ci.o cs_dmperm_ci.o cs_updown_ci.o cs_print_ci.o \
	cs_norm_ci.o cs_load_ci.o cs_dfs_ci.o cs_reach_ci.o cs_spsolve_ci.o \
	cs_leaf_ci.o cs_ereach_ci.o cs_randperm_ci.o

CS_CL_OBJ =  cs_add_cl.o cs_amd_cl.o cs_chol_cl.o cs_cholsol_cl.o cs_counts_cl.o \
	cs_cumsum_cl.o cs_droptol_cl.o cs_dropzeros_cl.o cs_dupl_cl.o \
	cs_entry_cl.o cs_etree_cl.o cs_fkeep_cl.o cs_gaxpy_cl.o cs_happly_cl.o \
	cs_house_cl.o cs_ipvec_cl.o cs_lsolve_cl.o cs_ltsolve_cl.o cs_lu_cl.o \
	cs_lusol_cl.o cs_util_cl.o cs_multiply_cl.o cs_permute_cl.o cs_pinv_cl.o \
	cs_post_cl.o cs_pvec_cl.o cs_qr_cl.o cs_qrsol_cl.o cs_scatter_cl.o \
	cs_schol_cl.o cs_sqr_cl.o cs_symperm_cl.o cs_tdfs_cl.o cs_malloc_cl.o \
	cs_transpose_cl.o cs_compress_cl.o cs_usolve_cl.o cs_utsolve_cl.o \
	cs_scc_cl.o cs_maxtrans_cl.o cs_dmperm_cl.o cs_updown_cl.o cs_print_cl.o \
	cs_norm_cl.o cs_load_cl.o cs_dfs_cl.o cs_reach_cl.o cs_spsolve_cl.o \
	cs_leaf_cl.o cs_ereach_cl.o cs_randperm_cl.o

CS = cs_convert.o $(CS_DI_OBJ) $(CS_DL_OBJ) $(CS_CI_OBJ) $(CS_CL_OBJ)

$(CS): ../Include/cs.h Makefile

cs_convert.o: ../Source/cs_convert.c
	$(CC) $(CF) $(I) -c $< -o $@

%_di.o : ../Source/%.c
	$(CC) $(CF) $(I) -c $< -o $@

%_dl.o : ../Source/%.c
	$(CC) $(CF) $(I) -DCS_LONG -c $< -o $@

%_ci.o : ../Source/%.c
	$(CC) $(CF) $(I) -DCS_COMPLEX -c $< -o $@

%_cl.o : ../Source/%.c
	$(CC) $(CF) $(I) -DCS_LONG -DCS_COMPLEX -c $< -o $@

static: $(AR_TARGET)

$(AR_TARGET): $(CS)
	$(ARCHIVE) $@ $^
	- $(RANLIB) $@

clean:
	- $(RM) -r $(CLEAN)

purge: distclean

distclean: clean
	- $(RM) -r $(PURGE)

# install CXSparse
install: $(AR_TARGET) $(INSTALL_LIB)/$(SO_TARGET)

$(INSTALL_LIB)/$(SO_TARGET): $(CS)
	@mkdir -p $(INSTALL_LIB)
	@mkdir -p $(INSTALL_INCLUDE)
	@mkdir -p $(INSTALL_DOC)
	$(CC) $(SO_OPTS) $^ -o $@ $(LDLIBS)
	( cd $(INSTALL_LIB) ; ln -sf $(SO_TARGET) $(SO_PLAIN) )
	( cd $(INSTALL_LIB) ; ln -sf $(SO_TARGET) $(SO_MAIN) )
	$(CP) ../Include/cs.h $(INSTALL_INCLUDE)
	$(CP) ../README.txt $(INSTALL_DOC)/CXSPARSE_README.txt
	chmod 755 $(INSTALL_LIB)/$(SO_TARGET)
	chmod 644 $(INSTALL_INCLUDE)/cs.h
	chmod 644 $(INSTALL_DOC)/CXSPARSE_README.txt

# uninstall CXSparse
uninstall:
	$(RM) $(INSTALL_LIB)/$(SO_TARGET)
	$(RM) $(INSTALL_LIB)/$(SO_PLAIN)
	$(RM) $(INSTALL_LIB)/$(SO_MAIN)
	$(RM) $(INSTALL_INCLUDE)/cs.h
	$(RM) $(INSTALL_DOC)/CXSPARSE_README.txt

=== KLU/Doc/Makefile ===
#------------------------------------------------------------------------------
# KLU Makefile for creating the user guide
#------------------------------------------------------------------------------

default: dist

include ../../SuiteSparse_config/SuiteSparse_config.mk

#------------------------------------------------------------------------------
# Remove all but the files in the original distribution
#------------------------------------------------------------------------------

clean:
	- $(RM) -r $(CLEAN)

purge: distclean

distclean: clean
	- $(RM) -r $(PURGE)

#------------------------------------------------------------------------------
# Create the User Guide and Quick Start Guide
#------------------------------------------------------------------------------

KLU_UserGuide.pdf: KLU_UserGuide.tex KLU_UserGuide.bib \
    ../Include/klu.h ../../BTF/Include/btf.h Makefile
	echo '\begin{verbatim}' > klu_h.tex
	expand -8 ../Include/klu.h >> klu_h.tex
	echo '\end{verbatim}' >> klu_h.tex
	echo '\begin{verbatim}' > btf_h.tex
	expand -8 ../../BTF/Include/btf.h >> btf_h.tex
	echo '\end{verbatim}' >> btf_h.tex
	echo '\begin{verbatim}' > klu_simple_c.tex
	expand -8 ../Demo/klu_simple.c >> klu_simple_c.tex
	echo '\end{verbatim}' >> klu_simple_c.tex
	pdflatex KLU_UserGuide
	bibtex KLU_UserGuide
	pdflatex KLU_UserGuide
	pdflatex KLU_UserGuide

dist:  KLU_UserGuide.pdf
	- $(RM) *.aux *.bbl *.blg *.log *.toc
	- $(RM) klu_simple_c.tex klu_h.tex btf_h.tex

=== SPQR/Lib/Makefile ===
#===============================================================================
# SuiteSparseQR/Lib/Makefile
#===============================================================================

LIBRARY = libspqr
VERSION = 2.0.8
SO_VERSION = 2

default: library

ccode: all

include ../../SuiteSparse_config/SuiteSparse_config.mk

# SPQR depends on CHOLMOD, AMD, COLAMD, LAPACK, the BLAS and SuiteSparse_config
LDLIBS += -lamd -lcolamd -lcholmod -lsuitesparseconfig $(LAPACK) $(BLAS)

# compile and install in SuiteSparse/lib
library:
	$(MAKE) install INSTALL=$(SUITESPARSE)

#-------------------------------------------------------------------------------

all: library

purge: distclean

distclean: clean
	- $(RM) -r $(PURGE)

clean:
	- $(RM) -r $(CLEAN)

INC = ../Include/spqr.hpp ../Include/SuiteSparseQR_C.h \
	../Include/SuiteSparseQR_definitions.h \
	../Include/SuiteSparseQR.hpp

OBJ = \
    spqr_rmap.o \
    SuiteSparseQR_C.o \
    SuiteSparseQR_expert.o \
    spqr_parallel.o \
    spqr_kernel.o \
    spqr_analyze.o \
    spqr_assemble.o \
    spqr_cpack.o \
    spqr_csize.o \
    spqr_fcsize.o \
    spqr_debug.o \
    spqr_front.o \
    spqr_factorize.o \
    spqr_freenum.o \
    spqr_freesym.o \
    spqr_freefac.o \
    spqr_fsize.o \
    spqr_maxcolnorm.o \
    spqr_rconvert.o \
    spqr_rcount.o \
    spqr_rhpack.o \
    spqr_rsolve.o \
    spqr_stranspose1.o \
    spqr_stranspose2.o \
    spqr_hpinv.o \
    spqr_1fixed.o \
    spqr_1colamd.o \
    SuiteSparseQR.o \
    spqr_1factor.o \
    spqr_cumsum.o \
    spqr_shift.o \
    spqr_happly.o \
    spqr_panel.o \
    spqr_happly_work.o \
    SuiteSparseQR_qmult.o \
    spqr_trapezoidal.o \
    spqr_larftb.o \
    spqr_append.o \
    spqr_type.o \
    spqr_tol.o

ifneq ($(GPU_CONFIG),)
OBJ += \
    spqrgpu_kernel.o \
    spqrgpu_buildAssemblyMaps.o \
    spqrgpu_computeFrontStaging.o
endif

$(OBJ): $(INC)

I = -I../../CHOLMOD/Include -I../../SuiteSparse_config -I../Include

ifneq ($(GPU_CONFIG),)
    I += -I../../SuiteSparse_GPURuntime/Include \
         -I../../GPUQREngine/Include $(CUDA_INC)
endif

C = $(CXX) $(CF) $(SPQR_CONFIG) $(CHOLMOD_CONFIG) $(CONFIG_PARTITION) $(I)

ifneq ($(GPU_CONFIG),)
    LDLIBS += $(CUDART_LIB) $(CUBLAS_LIB) \
        -lSuiteSparse_GPURuntime -lGPUQREngine
endif

#-------------------------------------------------------------------------------

static: $(AR_TARGET)

$(AR_TARGET): $(OBJ)
	$(ARCHIVE) $@ $^
	- $(RANLIB) $@

#-------------------------------------------------------------------------------

spqr_1colamd.o: ../Source/spqr_1colamd.cpp
	$(C) -c $<

spqr_1factor.o: ../Source/spqr_1factor.cpp
	$(C) -c $<

spqr_1fixed.o: ../Source/spqr_1fixed.cpp
	$(C) -c $<

spqr_analyze.o: ../Source/spqr_analyze.cpp
	$(C) -c $<

spqr_parallel.o: ../Source/spqr_parallel.cpp
	$(C) -c $<

spqr_kernel.o: ../Source/spqr_kernel.cpp
	$(C) -c $<

spqr_append.o: ../Source/spqr_append.cpp
	$(C) -c $<

spqr_assemble.o: ../Source/spqr_assemble.cpp
	$(C) -c $<

spqr_cpack.o: ../Source/spqr_cpack.cpp
	$(C) -c $<

spqr_csize.o: ../Source/spqr_csize.cpp
	$(C) -c $<

spqr_cumsum.o: ../Source/spqr_cumsum.cpp
	$(C) -c $<

spqr_debug.o: ../Source/spqr_debug.cpp
	$(C) -c $<

spqr_factorize.o: ../Source/spqr_factorize.cpp
	$(C) -c $<

spqr_fcsize.o: ../Source/spqr_fcsize.cpp
	$(C) -c $<

spqr_freefac.o: ../Source/spqr_freefac.cpp
	$(C) -c $<

spqr_freenum.o: ../Source/spqr_freenum.cpp
	$(C) -c $<

spqr_freesym.o: ../Source/spqr_freesym.cpp
	$(C) -c $<

spqr_fsize.o: ../Source/spqr_fsize.cpp
	$(C) -c $<

spqr_happly.o: ../Source/spqr_happly.cpp
	$(C) -c $<

spqr_panel.o: ../Source/spqr_panel.cpp
	$(C) -c $<

spqr_happly_work.o: ../Source/spqr_happly_work.cpp
	$(C) -c $<

spqr_hpinv.o: ../Source/spqr_hpinv.cpp
	$(C) -c $<

spqr_larftb.o: ../Source/spqr_larftb.cpp
	$(C) -c $<

spqr_rconvert.o: ../Source/spqr_rconvert.cpp
	$(C) -c $<

spqr_rcount.o: ../Source/spqr_rcount.cpp
	$(C) -c $<

spqr_rhpack.o: ../Source/spqr_rhpack.cpp
	$(C) -c $<

spqr_rsolve.o: ../Source/spqr_rsolve.cpp
	$(C) -c $<

spqr_shift.o: ../Source/spqr_shift.cpp
	$(C) -c $<

spqr_stranspose1.o: ../Source/spqr_stranspose1.cpp
	$(C) -c $<

spqr_stranspose2.o: ../Source/spqr_stranspose2.cpp
	$(C) -c $<

spqr_trapezoidal.o: ../Source/spqr_trapezoidal.cpp
	$(C) -c $<

spqr_type.o: ../Source/spqr_type.cpp
	$(C) -c $<

spqr_front.o: ../Source/spqr_front.cpp
	$(C) -c $<

SuiteSparseQR_expert.o: ../Source/SuiteSparseQR_expert.cpp
	$(C) -c $<

spqr_maxcolnorm.o: ../Source/spqr_maxcolnorm.cpp
	$(C) -c $<

SuiteSparseQR_qmult.o: ../Source/SuiteSparseQR_qmult.cpp
	$(C) -c $<

SuiteSparseQR.o: ../Source/SuiteSparseQR.cpp
	$(C) -c $<

spqr_tol.o: ../Source/spqr_tol.cpp
	$(C) -c $<

SuiteSparseQR_C.o: ../Source/SuiteSparseQR_C.cpp
	$(C) -c $<

spqr_rmap.o: ../Source/spqr_rmap.cpp
	$(C) -c $<

spqrgpu_kernel.o: ../SPQRGPU/spqrgpu_kernel.cpp
	$(C) -c $<

spqrgpu_buildAssemblyMaps.o: ../SPQRGPU/spqrgpu_buildAssemblyMaps.cpp
	$(C) -c $<

spqrgpu_computeFrontStaging.o: ../SPQRGPU/spqrgpu_computeFrontStaging.cpp
	$(C) -c $<

#-------------------------------------------------------------------------------

# install SPQR
install: $(AR_TARGET) $(INSTALL_LIB)/$(SO_TARGET)

$(INSTALL_LIB)/$(SO_TARGET): $(OBJ)
	@mkdir -p $(INSTALL_LIB)
	@mkdir -p $(INSTALL_INCLUDE)
	@mkdir -p $(INSTALL_DOC)
	$(CXX) $(SO_OPTS) $^ -o $@ $(LDLIBS)
	( cd $(INSTALL_LIB) ; ln -sf $(SO_TARGET) $(SO_PLAIN) )
	( cd $(INSTALL_LIB) ; ln -sf $(SO_TARGET) $(SO_MAIN) )
	$(CP) ../Include/SuiteSparseQR.hpp $(INSTALL_INCLUDE)
	$(CP) ../Include/SuiteSparseQR_C.h $(INSTALL_INCLUDE)
	$(CP) ../Include/SuiteSparseQR_definitions.h $(INSTALL_INCLUDE)
	$(CP) ../Include/spqr.hpp $(INSTALL_INCLUDE)
	$(CP) ../Doc/spqr_user_guide.pdf $(INSTALL_DOC)
	$(CP) ../README.txt $(INSTALL_DOC)/SPQR_README.txt
	chmod 755 $(INSTALL_LIB)/$(SO_TARGET)
	chmod 644 $(INSTALL_INCLUDE)/SuiteSparseQR.hpp
	chmod 644 $(INSTALL_INCLUDE)/SuiteSparseQR_C.h
	chmod 644 $(INSTALL_INCLUDE)/SuiteSparseQR_definitions.h
	chmod 644 $(INSTALL_INCLUDE)/spqr.hpp
	chmod 644 $(INSTALL_DOC)/spqr_user_guide.pdf
	chmod 644 $(INSTALL_DOC)/SPQR_README.txt

# uninstall SPQR
uninstall:
	$(RM) $(INSTALL_LIB)/$(SO_TARGET)
	$(RM) $(INSTALL_LIB)/$(SO_PLAIN)
	$(RM) $(INSTALL_LIB)/$(SO_MAIN)
	$(RM) $(INSTALL_INCLUDE)/SuiteSparseQR.hpp
	$(RM) $(INSTALL_INCLUDE)/SuiteSparseQR_C.h
	$(RM) $(INSTALL_INCLUDE)/SuiteSparseQR_definitions.h
	$(RM) $(INSTALL_INCLUDE)/spqr.hpp
	$(RM) $(INSTALL_DOC)/spqr_user_guide.pdf
	$(RM) $(INSTALL_DOC)/SPQR_README.txt

=== debian/changelog ===
suitesparse (1:4.5.4-1) unstable; urgency=medium

  * New upstream version 4.5.4

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 17 Dec 2016 10:37:55 +0100

suitesparse (1:4.5.3-2) unstable; urgency=medium

  * Remove Christophe Prud'homme from Uploaders (per MIA team request).
    Thanks Christophe for your contributions to that package! (Closes: #835011)
  * Bump to debhelper compat level 10.
  * Stop using dh-exec.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 30 Oct 2016 14:27:47 +0100

=== debian/control ===
Source: suitesparse
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Build-Depends: debhelper (>= 10), gfortran, libblas-dev, liblapack-dev,
 libmetis-dev
Standards-Version: 3.9.8
Homepage: http://www.suitesparse.com
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/suitesparse.git
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/suitesparse.git

Package: libamd2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: approximate minimum degree ordering library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The AMD library provides a set of routines for pre-ordering sparse matrices
 prior to Cholesky or LU factorization, using the "Approximate Minimum Degree
 ordering" algorithm.

Package: libbtf1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: permutation to block triangular form library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The BTF library is a software package for permuting a matrix into Block upper
 Triangular Form. It includes a maximum transversal algorithm, which finds a
 permutation of a square or rectangular matrix so that it has a zero-free
 diagonal (if one exists); otherwise, it finds a maximal matching which
 maximizes the number of nonzeros on the diagonal. The package also includes a
 method for finding the strongly connected components of a graph. These two
 methods together give the permutation to block upper triangular form.

Package: libcamd2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: symmetric approximate minimum degree library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CAMD library provides a set of routines for pre-ordering sparse matrices
 prior to Cholesky or LU factorization, using the approximate minimum degree
 ordering algorithm with optional ordering constraints.

Package: libcolamd2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: column approximate minimum degree ordering library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The COLAMD library implements the "COLumn Approximate Minimum Degree ordering"
 algorithm. It computes a permutation vector P such that the LU factorization
 of A (:,P) tends to be sparser than that of A. The Cholesky factorization of
 (A (:,P))'*(A (:,P)) will also tend to be sparser than that of A'*A.

Package: libccolamd2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: constrained column approximate library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CCOLAMD library implements the "Constrained COLumn Approximate Minimum
 Degree ordering" algorithm. It computes a permutation vector P such that the
 LU factorization of A (:,P) tends to be sparser than that of A. The Cholesky
 factorization of (A (:,P))'*(A (:,P)) will also tend to be sparser than that
 of A'*A.

Package: libcholmod3
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sparse Cholesky factorization library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CHOLMOD library provides a set of routines for factorizing sparse
 symmetric positive definite matrices of the form A or AA', updating/downdating
 a sparse Cholesky factorization, solving linear systems, updating/downdating
 the solution to the triangular system Lx=b, and many other sparse matrix
 functions for both symmetric and unsymmetric matrices. Its supernodal Cholesky
 factorization relies on LAPACK and the Level-3 BLAS, and obtains a substantial
 fraction of the peak performance of the BLAS.

Package: libcxsparse3
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: concise sparse matrix library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CXSparse library provides several matrix algorithms. The focus is on direct
 methods; iterative methods and solvers for eigenvalue problems are beyond the
 scope of this package.
 .
 The performance of the sparse factorization methods in CXSparse will not be
 competitive with UMFPACK or CHOLMOD, but the codes are much more concise and
 easy to understand. Other methods are competitive.

Package: libklu1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: circuit simulation sparse LU factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The KLU library provides routines for LU factorization, primarily for circuit
 simulation.

Package: libldl2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: simple LDL' factorization library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The LDL library provides routines for sparse LDL' factorization and solving.
 These routines are not terrifically fast (they do not use dense matrix
 kernels), but the code is very short and concise. The purpose is to illustrate
 the algorithms in a very concise and readable manner, primarily for
 educational purposes.

Package: libumfpack5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sparse LU factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The UMFPACK library provides a set of routines solving sparse linear systems
 via LU factorization.

Package: librbio2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: read/write sparse matrices in Rutherford/Boeing format
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 RBio is a library for reading/writing sparse matrices in the Rutherford/Boeing
 format.

Package: libspqr2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sparse QR factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 SuiteSparseQR (SPQR) is a multithreaded, multifrontal, rank-revealing sparse
 QR factorization method.

Package: libsuitesparseconfig4
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: configuration routines for all SuiteSparse modules
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The SuiteSparse_config library provides configuration routines that are common
 to all SuiteSparse libraries.

Package: libsuitesparse-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libsuitesparse-metis-dev
Conflicts: libsuitesparse-metis-dev
Depends: ${misc:Depends},
 libamd2 (= ${binary:Version}),
 libcamd2 (= ${binary:Version}),
 libbtf1 (= ${binary:Version}),
 libcolamd2 (= ${binary:Version}),
 libccolamd2 (= ${binary:Version}),
 libcholmod3 (= ${binary:Version}),
 libcxsparse3 (= ${binary:Version}),
 libklu1 (= ${binary:Version}),
 libldl2 (= ${binary:Version}),
 libumfpack5 (= ${binary:Version}),
 librbio2 (= ${binary:Version}),
 libspqr2 (= ${binary:Version}),
 libsuitesparseconfig4 (= ${binary:Version}),
 libblas-dev | libblas.so,
 liblapack-dev | liblapack.so
Description: libraries for sparse matrices computations (development files)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following libraries:
 .
 AMD         approximate minimum degree ordering
 .
 CAMD        symmetric approximate minimum degree
 .
 BTF         permutation to block triangular form (beta)
 .
 COLAMD      column approximate minimum degree ordering
 .
 CCOLAMD     constrained column approximate minimum degree ordering
 .
 CHOLMOD     sparse Cholesky factorization
 .
 CXSparse    a concise sparse matrix package
 .
 KLU         sparse LU factorization, primarily for circuit simulation
 .
 LDL         a simple LDL' factorization
 .
 UMFPACK     sparse LU factorization
 .
 RBio        read/write sparse matrices in Rutherford/Boeing format
 .
 SPQR        sparse QR factorization
 .
 SuiteSparse_config    configuration routines for all the above packages.
 .
 This package contains the static libraries and header files.

Package: libsuitesparse-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: liblapack-doc, liblapack-doc-man, libatlas-doc
Description: libraries for sparse matrices computations (documentation)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices. This package contains the user guides for the
 libraries distributed by the SuiteSparse project.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildflags.mk

COMMON_FLAGS := BLAS=-lblas MY_METIS_LIB=-lmetis
PIC_FLAGS := $(COMMON_FLAGS) OPTIMIZATION=-fPIC
NOPIC_FLAGS := $(COMMON_FLAGS) OPTIMIZATION=

STATIC_LIBS := CAMD/Lib/libcamd.a BTF/Lib/libbtf.a CHOLMOD/Lib/libcholmod.a AMD/Lib/libamd.a RBio/Lib/librbio.a LDL/Lib/libldl.a SuiteSparse_config/libsuitesparseconfig.a KLU/Lib/libklu.a SPQR/Lib/libspqr.a UMFPACK/Lib/libumfpack.a COLAMD/Lib/libcolamd.a CXSparse/Lib/libcxsparse.a CCOLAMD/Lib/libccolamd.a

%:
	dh $@

# LD_LIBRARY_PATH needed to make tests work (since buildflags.patch removes the -rpath)
override_dh_auto_build:
	# Build static libraries
	dh_auto_build -- static $(NOPIC_FLAGS)
	mkdir static_lib && cp $(STATIC_LIBS) static_lib/
	make purge

	# Build dynamic libraries
	LD_LIBRARY_PATH=$$(pwd)/lib dh_auto_build -- $(PIC_FLAGS)

override_dh_auto_install:
	make install $(PIC_FLAGS) INSTALL=$$(pwd)/debian/tmp/usr INSTALL_LIB=$$(pwd)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/ INSTALL_INCLUDE=$$(pwd)/debian/tmp/usr/include/suitesparse INSTALL_DOC=$$(pwd)/debian/tmp/usr/share/doc/suitesparse
	cp static_lib/* $$(pwd)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/

override_dh_auto_clean:
	make purge
	rm -rf static_lib

override_dh_strip:
	dh_strip --dbgsym-migration='libsuitesparse-dbg (<< 1:4.4.6-1~)'

override_dh_compress:
	dh_compress -X.pdf

get-orig-source:
	uscan --force-download --rename --destdir .
.PHONY: get-orig-source

## suitesparse 4.5.5

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 
 # install all packages in /usr/local/lib and /usr/local/include
 # (note that CSparse is not installed; CXSparse is installed instead)
-install: metis
+install: metisinstall
 	( cd SuiteSparse_config && $(MAKE) install )
 	( cd AMD && $(MAKE) install )
 	( cd BTF && $(MAKE) install )
@@ -56,8 +56,13 @@
 #	( cd SKYLINE_SVD && $(MAKE) install )
 	$(CP) README.txt $(INSTALL_DOC)/SuiteSparse_README.txt
 	chmod 644 $(INSTALL_DOC)/SuiteSparse_README.txt
+
+metisinstall: metis
 ifeq (,$(MY_METIS_LIB))
         # install METIS from SuiteSparse/metis-5.1.0
+	@mkdir -p $(INSTALL_LIB)
+	@mkdir -p $(INSTALL_INCLUDE)
+	@mkdir -p $(INSTALL_DOC)
 	- $(CP) lib/libmetis.* $(INSTALL_LIB)
 	- $(CP) metis-5.1.0/manual/manual.pdf $(INSTALL_DOC)/METIS_manual.pdf
 	- $(CP) metis-5.1.0/README.txt $(INSTALL_DOC)/METIS_README.txt

=== debian/changelog ===
suitesparse (1:4.5.5-1) unstable; urgency=medium

  * New upstream version 4.5.5
  * d/copyright: use secure URL for format.
  * d/watch: bump to format version 4.
  * d/control:
    + Use canonical URL for Vcs-Browser.
    + Bump Standards-Version to 4.0.0, no changes needed.

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 19 Jun 2017 11:28:17 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Uploaders: Sébastien Villemot <sebastien@debian.org>
 Build-Depends: debhelper (>= 10), gfortran, libblas-dev, liblapack-dev,
  libmetis-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://www.suitesparse.com
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/suitesparse.git
-Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/suitesparse.git
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/suitesparse.git
 
 Package: libamd2
 Section: libs

=== debian/watch ===
version=4
http://www.suitesparse.com \
(?:|.*/)SuiteSparse(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
